-- name: [CS] Rex
-- description: The OG Evil Yoshi!\n\nMade by: ThaGurlTilly\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

local TEXT_MOD_NAME = "Rex"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end


local E_MODEL_REX =      smlua_model_util_get_id("rex_geo")

local TEX_REX_LIFE_ICON = get_texture_info("RexHudsmal")

local VOICETABLE_REX = {
    [CHAR_SOUND_OKEY_DOKEY] = 'Silent.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'smw_1-up.ogg',
	[CHAR_SOUND_PUNCH_YAH] = 'smw_kick.ogg',
	[CHAR_SOUND_PUNCH_WAH] = 'smw_stomp_no_damage.ogg',
	[CHAR_SOUND_PUNCH_HOO] = 'smw_stomp_koopa_kid.ogg',
	[CHAR_SOUND_YAH_WAH_HOO] = {'smw_jump.ogg', 'smw_jump.ogg', 'smw_jump.ogg'},
	[CHAR_SOUND_HOOHOO] = 'smw_spin_jump.ogg',
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'smw_cape_rise.ogg', 'smw_cape_rise.ogg'},
	[CHAR_SOUND_UH] = 'smw_yoshi_stomp.ogg',
	[CHAR_SOUND_UH2] = 'smw_reserve_item_store.ogg',
	[CHAR_SOUND_UH2_2] = 'Silent.ogg',
	[CHAR_SOUND_HAHA] = 'smw_midway_gate.ogg',
	[CHAR_SOUND_YAHOO] = 'smw_cape_rise.ogg',
	[CHAR_SOUND_DOH] = 'smw_yoshi_stomp.ogg',
	[CHAR_SOUND_WHOA] = 'Silent.ogg',
	[CHAR_SOUND_EEUH] = 'Silent.ogg',
	[CHAR_SOUND_WAAAOOOW] = 'smw_lemmy_wendy_falls_out_of_pipe.ogg',
	[CHAR_SOUND_TWIRL_BOUNCE] = 'smw_spin_jump.ogg',
	[CHAR_SOUND_GROUND_POUND_WAH] = 'smw_yoshi_stomp.ogg', 
	[CHAR_SOUND_HRMM] = 'smw_reserve_item_store.ogg',
	[CHAR_SOUND_HERE_WE_GO] = 'smw_goal_iris-out.ogg',
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'smw_bowser_flies_away.ogg',
	[CHAR_SOUND_ATTACKED] = 'smw_pipe.ogg',
	[CHAR_SOUND_PANTING] = 'smw_swimming.ogg',
	[CHAR_SOUND_ON_FIRE] = 'smw_yoshi_runs_away.ogg',
	[CHAR_SOUND_IMA_TIRED] = 'smw_yoshi_spit.ogg',
	[CHAR_SOUND_YAWNING] = 'smw_yoshi_spit.ogg',
	[CHAR_SOUND_SNORING1] = 'smw_swimming.ogg',
	[CHAR_SOUND_SNORING2] = 'smw_swimming.ogg',
	[CHAR_SOUND_SNORING3] = 'smw_swimming.ogg',
	[CHAR_SOUND_COUGHING1] = 'smw_yoshi_spit.ogg',
	[CHAR_SOUND_COUGHING2] = 'smw_yoshi_spit.ogg',
	[CHAR_SOUND_COUGHING3] = 'smw_yoshi_spit.ogg',
	[CHAR_SOUND_DYING] = 'smw_lost_a_life.ogg',
	[CHAR_SOUND_DROWNING] = 'smw_lost_a_life.ogg',
	[CHAR_SOUND_MAMA_MIA] = 'smw_ludwig_morton_roy_beat.ogg'
}


local CAPTABLE_REX = {
    normal = smlua_model_util_get_id("rex_horn_geo"),
    wing = smlua_model_util_get_id("flyers_manual_geo"),
    metal = smlua_model_util_get_id("metal_mushroom_geo"),
}


local PALETTE_REX = {
    [PANTS]  = "f88000",
    [SHIRT]  = "4a37d3",
    [GLOVES] = "ffffff",
    [SHOES]  = "ff0000",
    [HAIR]   = "ffffff",
    [SKIN]   = "ffde39",
    [CAP]    = "4a37d3",
	[EMBLEM] = "ffffff"
}

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add(
        "Rex", -- 
        "The OG Evil Yoshi",
        "ThaGurlTilly",
        "4a37d3",
        E_MODEL_REX,     
        CT_MARIO,         
        TEX_REX_LIFE_ICON,
        1,                 
        0                  
    )

	_G.charSelect.character_add_caps(E_MODEL_REX, CAPTABLE_REX)

	_G.charSelect.character_add_voice(E_MODEL_REX, VOICETABLE_REX)

    _G.charSelect.character_add_palette_preset(E_MODEL_REX, PALETTE_REX)

    _G.charSelect.credit_add(TEXT_MOD_NAME, "ThaGurlTilly", "Pack")
	
	_G.charSelect.credit_add(TEXT_MOD_NAME, "deepfriedclyde", "SGI Yoshi Render Rig")
	
	_G.charSelect.credit_add(TEXT_MOD_NAME, "FluffaMario", "[CS] Extra Characters Yoshi")
	
	_G.charSelect.credit_add(TEXT_MOD_NAME, "Garrulous64", "Voicetable")

    CSloaded = true
end


local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_REX then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_REX then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)